<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;regex-1.5.4&#x2F;src&#x2F;prog.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>prog.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../regex/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::cmp::Ordering</span>;
<span class="kw">use</span> <span class="ident">std::collections::HashMap</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::mem</span>;
<span class="kw">use</span> <span class="ident">std::ops::Deref</span>;
<span class="kw">use</span> <span class="ident">std::slice</span>;
<span class="kw">use</span> <span class="ident">std::sync::Arc</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::input::Char</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::literal::LiteralSearcher</span>;

<span class="doccomment">/// `InstPtr` represents the index of an instruction in a regex program.</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">InstPtr</span> <span class="op">=</span> <span class="ident">usize</span>;

<span class="doccomment">/// Program is a sequence of instructions and various facts about thos</span>
<span class="doccomment">/// instructions.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Program</span> {
    <span class="doccomment">/// A sequence of instructions that represents an NFA.</span>
    <span class="kw">pub</span> <span class="ident">insts</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Inst</span><span class="op">&gt;</span>,
    <span class="doccomment">/// Pointers to each Match instruction in the sequence.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is always length 1 unless this program represents a regex set.</span>
    <span class="kw">pub</span> <span class="ident">matches</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">InstPtr</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The ordered sequence of all capture groups extracted from the AST.</span>
    <span class="doccomment">/// Unnamed groups are `None`.</span>
    <span class="kw">pub</span> <span class="ident">captures</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="doccomment">/// Pointers to all named capture groups into `captures`.</span>
    <span class="kw">pub</span> <span class="ident">capture_name_idx</span>: <span class="ident">Arc</span><span class="op">&lt;</span><span class="ident">HashMap</span><span class="op">&lt;</span><span class="ident">String</span>, <span class="ident">usize</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="doccomment">/// A pointer to the start instruction. This can vary depending on how</span>
    <span class="doccomment">/// the program was compiled. For example, programs for use with the DFA</span>
    <span class="doccomment">/// engine have a `.*?` inserted at the beginning of unanchored regular</span>
    <span class="doccomment">/// expressions. The actual starting point of the program is after the</span>
    <span class="doccomment">/// `.*?`.</span>
    <span class="kw">pub</span> <span class="ident">start</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// A set of equivalence classes for discriminating bytes in the compiled</span>
    <span class="doccomment">/// program.</span>
    <span class="kw">pub</span> <span class="ident">byte_classes</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
    <span class="doccomment">/// When true, this program can only match valid UTF-8.</span>
    <span class="kw">pub</span> <span class="ident">only_utf8</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// When true, this program uses byte range instructions instead of Unicode</span>
    <span class="doccomment">/// range instructions.</span>
    <span class="kw">pub</span> <span class="ident">is_bytes</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// When true, the program is compiled for DFA matching. For example, this</span>
    <span class="doccomment">/// implies `is_bytes` and also inserts a preceding `.*?` for unanchored</span>
    <span class="doccomment">/// regexes.</span>
    <span class="kw">pub</span> <span class="ident">is_dfa</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// When true, the program matches text in reverse (for use only in the</span>
    <span class="doccomment">/// DFA).</span>
    <span class="kw">pub</span> <span class="ident">is_reverse</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// Whether the regex must match from the start of the input.</span>
    <span class="kw">pub</span> <span class="ident">is_anchored_start</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// Whether the regex must match at the end of the input.</span>
    <span class="kw">pub</span> <span class="ident">is_anchored_end</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// Whether this program contains a Unicode word boundary instruction.</span>
    <span class="kw">pub</span> <span class="ident">has_unicode_word_boundary</span>: <span class="ident">bool</span>,
    <span class="doccomment">/// A possibly empty machine for very quickly matching prefix literals.</span>
    <span class="kw">pub</span> <span class="ident">prefixes</span>: <span class="ident">LiteralSearcher</span>,
    <span class="doccomment">/// A limit on the size of the cache that the DFA is allowed to use while</span>
    <span class="doccomment">/// matching.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The cache limit specifies approximately how much space we&#39;re willing to</span>
    <span class="doccomment">/// give to the state cache. Once the state cache exceeds the size, it is</span>
    <span class="doccomment">/// wiped and all states must be re-computed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that this value does not impact correctness. It can be set to 0</span>
    <span class="doccomment">/// and the DFA will run just fine. (It will only ever store exactly one</span>
    <span class="doccomment">/// state in the cache, and will likely run very slowly, but it will work.)</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Also note that this limit is *per thread of execution*. That is,</span>
    <span class="doccomment">/// if the same regex is used to search text across multiple threads</span>
    <span class="doccomment">/// simultaneously, then the DFA cache is not shared. Instead, copies are</span>
    <span class="doccomment">/// made.</span>
    <span class="kw">pub</span> <span class="ident">dfa_size_limit</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">Program</span> {
    <span class="doccomment">/// Creates an empty instruction sequence. Fields are given default</span>
    <span class="doccomment">/// values.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">Program</span> {
            <span class="ident">insts</span>: <span class="macro">vec!</span>[],
            <span class="ident">matches</span>: <span class="macro">vec!</span>[],
            <span class="ident">captures</span>: <span class="macro">vec!</span>[],
            <span class="ident">capture_name_idx</span>: <span class="ident">Arc::new</span>(<span class="ident">HashMap::new</span>()),
            <span class="ident">start</span>: <span class="number">0</span>,
            <span class="ident">byte_classes</span>: <span class="macro">vec!</span>[<span class="number">0</span>; <span class="number">256</span>],
            <span class="ident">only_utf8</span>: <span class="bool-val">true</span>,
            <span class="ident">is_bytes</span>: <span class="bool-val">false</span>,
            <span class="ident">is_dfa</span>: <span class="bool-val">false</span>,
            <span class="ident">is_reverse</span>: <span class="bool-val">false</span>,
            <span class="ident">is_anchored_start</span>: <span class="bool-val">false</span>,
            <span class="ident">is_anchored_end</span>: <span class="bool-val">false</span>,
            <span class="ident">has_unicode_word_boundary</span>: <span class="bool-val">false</span>,
            <span class="ident">prefixes</span>: <span class="ident">LiteralSearcher::empty</span>(),
            <span class="ident">dfa_size_limit</span>: <span class="number">2</span> <span class="op">*</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">20</span>),
        }
    }

    <span class="doccomment">/// If pc is an index to a no-op instruction (like Save), then return the</span>
    <span class="doccomment">/// next pc that is not a no-op instruction.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">skip</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="kw-2">mut</span> <span class="ident">pc</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="kw">loop</span> {
            <span class="kw">match</span> <span class="self">self</span>[<span class="ident">pc</span>] {
                <span class="ident">Inst::Save</span>(<span class="kw-2">ref</span> <span class="ident">i</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">pc</span> <span class="op">=</span> <span class="ident">i</span>.<span class="ident">goto</span>,
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="ident">pc</span>,
            }
        }
    }

    <span class="doccomment">/// Return true if and only if an execution engine at instruction `pc` will</span>
    <span class="doccomment">/// always lead to a match.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">leads_to_match</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">pc</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">1</span> {
            <span class="comment">// If we have a regex set, then we have more than one ending</span>
            <span class="comment">// state, so leading to one of those states is generally</span>
            <span class="comment">// meaningless.</span>
            <span class="kw">return</span> <span class="bool-val">false</span>;
        }
        <span class="kw">match</span> <span class="self">self</span>[<span class="self">self</span>.<span class="ident">skip</span>(<span class="ident">pc</span>)] {
            <span class="ident">Inst::Match</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">true</span>,
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">false</span>,
        }
    }

    <span class="doccomment">/// Returns true if the current configuration demands that an implicit</span>
    <span class="doccomment">/// `.*?` be prepended to the instruction sequence.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">needs_dotstar</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">is_dfa</span> <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">is_reverse</span> <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">is_anchored_start</span>
    }

    <span class="doccomment">/// Returns true if this program uses Byte instructions instead of</span>
    <span class="doccomment">/// Char/Range instructions.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">uses_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">is_bytes</span> <span class="op">|</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">is_dfa</span>
    }

    <span class="doccomment">/// Returns true if this program exclusively matches valid UTF-8 bytes.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// That is, if an invalid UTF-8 byte is seen, then no match is possible.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">only_utf8</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">only_utf8</span>
    }

    <span class="doccomment">/// Return the approximate heap usage of this instruction sequence in</span>
    <span class="doccomment">/// bytes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">approximate_size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="comment">// The only instruction that uses heap space is Ranges (for</span>
        <span class="comment">// Unicode codepoint programs) to store non-overlapping codepoint</span>
        <span class="comment">// ranges. To keep this operation constant time, we ignore them.</span>
        (<span class="self">self</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">Inst</span><span class="op">&gt;</span>())
            <span class="op">+</span> (<span class="self">self</span>.<span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">InstPtr</span><span class="op">&gt;</span>())
            <span class="op">+</span> (<span class="self">self</span>.<span class="ident">captures</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="op">&gt;</span>())
            <span class="op">+</span> (<span class="self">self</span>.<span class="ident">capture_name_idx</span>.<span class="ident">len</span>()
                <span class="op">*</span> (<span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>() <span class="op">+</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>()))
            <span class="op">+</span> (<span class="self">self</span>.<span class="ident">byte_classes</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>())
            <span class="op">+</span> <span class="self">self</span>.<span class="ident">prefixes</span>.<span class="ident">approximate_size</span>()
    }
}

<span class="kw">impl</span> <span class="ident">Deref</span> <span class="kw">for</span> <span class="ident">Program</span> {
    <span class="kw">type</span> <span class="ident">Target</span> <span class="op">=</span> [<span class="ident">Inst</span>];

    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;perf-inline&quot;</span>, <span class="ident">inline</span>(<span class="ident">always</span>))]</span>
    <span class="kw">fn</span> <span class="ident">deref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Target</span> {
        <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="self">self</span>.<span class="ident">insts</span>
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Program</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::Inst</span>::<span class="kw-2">*</span>;

        <span class="kw">fn</span> <span class="ident">with_goto</span>(<span class="ident">cur</span>: <span class="ident">usize</span>, <span class="ident">goto</span>: <span class="ident">usize</span>, <span class="ident">fmtd</span>: <span class="ident">String</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">String</span> {
            <span class="kw">if</span> <span class="ident">goto</span> <span class="op">=</span><span class="op">=</span> <span class="ident">cur</span> <span class="op">+</span> <span class="number">1</span> {
                <span class="ident">fmtd</span>
            } <span class="kw">else</span> {
                <span class="macro">format!</span>(<span class="string">&quot;{} (goto: {})&quot;</span>, <span class="ident">fmtd</span>, <span class="ident">goto</span>)
            }
        }

        <span class="kw">fn</span> <span class="ident">visible_byte</span>(<span class="ident">b</span>: <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">String</span> {
            <span class="kw">use</span> <span class="ident">std::ascii::escape_default</span>;
            <span class="kw">let</span> <span class="ident">escaped</span> <span class="op">=</span> <span class="ident">escape_default</span>(<span class="ident">b</span>).<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span>();
            <span class="ident">String::from_utf8_lossy</span>(<span class="kw-2">&amp;</span><span class="ident">escaped</span>).<span class="ident">into_owned</span>()
        }

        <span class="kw">for</span> (<span class="ident">pc</span>, <span class="ident">inst</span>) <span class="kw">in</span> <span class="self">self</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
            <span class="kw">match</span> <span class="kw-2">*</span><span class="ident">inst</span> {
                <span class="ident">Match</span>(<span class="ident">slot</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{:04} Match({:?})&quot;</span>, <span class="ident">pc</span>, <span class="ident">slot</span>)<span class="question-mark">?</span>,
                <span class="ident">Save</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{:04} Save({})&quot;</span>, <span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">slot</span>);
                    <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{}&quot;</span>, <span class="ident">with_goto</span>(<span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">s</span>))<span class="question-mark">?</span>;
                }
                <span class="ident">Split</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="macro">write!</span>(
                        <span class="ident">f</span>,
                        <span class="string">&quot;{:04} Split({}, {})&quot;</span>,
                        <span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto1</span>, <span class="ident">inst</span>.<span class="ident">goto2</span>
                    )<span class="question-mark">?</span>;
                }
                <span class="ident">EmptyLook</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">inst</span>.<span class="ident">look</span>);
                    <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{:04} {}&quot;</span>, <span class="ident">pc</span>, <span class="ident">with_goto</span>(<span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">s</span>))<span class="question-mark">?</span>;
                }
                <span class="ident">Char</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">inst</span>.<span class="ident">c</span>);
                    <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{:04} {}&quot;</span>, <span class="ident">pc</span>, <span class="ident">with_goto</span>(<span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">s</span>))<span class="question-mark">?</span>;
                }
                <span class="ident">Ranges</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">ranges</span> <span class="op">=</span> <span class="ident">inst</span>
                        .<span class="ident">ranges</span>
                        .<span class="ident">iter</span>()
                        .<span class="ident">map</span>(<span class="op">|</span><span class="ident">r</span><span class="op">|</span> <span class="macro">format!</span>(<span class="string">&quot;{:?}-{:?}&quot;</span>, <span class="ident">r</span>.<span class="number">0</span>, <span class="ident">r</span>.<span class="number">1</span>))
                        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="op">&gt;</span>()
                        .<span class="ident">join</span>(<span class="string">&quot;, &quot;</span>);
                    <span class="macro">write!</span>(
                        <span class="ident">f</span>,
                        <span class="string">&quot;{:04} {}&quot;</span>,
                        <span class="ident">pc</span>,
                        <span class="ident">with_goto</span>(<span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">ranges</span>)
                    )<span class="question-mark">?</span>;
                }
                <span class="ident">Bytes</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="macro">format!</span>(
                        <span class="string">&quot;Bytes({}, {})&quot;</span>,
                        <span class="ident">visible_byte</span>(<span class="ident">inst</span>.<span class="ident">start</span>),
                        <span class="ident">visible_byte</span>(<span class="ident">inst</span>.<span class="ident">end</span>)
                    );
                    <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{:04} {}&quot;</span>, <span class="ident">pc</span>, <span class="ident">with_goto</span>(<span class="ident">pc</span>, <span class="ident">inst</span>.<span class="ident">goto</span>, <span class="ident">s</span>))<span class="question-mark">?</span>;
                }
            }
            <span class="kw">if</span> <span class="ident">pc</span> <span class="op">=</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">start</span> {
                <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot; (start)&quot;</span>)<span class="question-mark">?</span>;
            }
            <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;\n&quot;</span>)<span class="question-mark">?</span>;
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">IntoIterator</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Program</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Inst</span>;
    <span class="kw">type</span> <span class="ident">IntoIter</span> <span class="op">=</span> <span class="ident">slice::Iter</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">Inst</span><span class="op">&gt;</span>;
    <span class="kw">fn</span> <span class="ident">into_iter</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident"><span class="self">Self</span>::IntoIter</span> {
        <span class="self">self</span>.<span class="ident">iter</span>()
    }
}

<span class="doccomment">/// Inst is an instruction code in a Regex program.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Regrettably, a regex program either contains Unicode codepoint</span>
<span class="doccomment">/// instructions (Char and Ranges) or it contains byte instructions (Bytes).</span>
<span class="doccomment">/// A regex program can never contain both.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// It would be worth investigating splitting this into two distinct types and</span>
<span class="doccomment">/// then figuring out how to make the matching engines polymorphic over those</span>
<span class="doccomment">/// types without sacrificing performance.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Other than the benefit of moving invariants into the type system, another</span>
<span class="doccomment">/// benefit is the decreased size. If we remove the `Char` and `Ranges`</span>
<span class="doccomment">/// instructions from the `Inst` enum, then its size shrinks from 32 bytes to</span>
<span class="doccomment">/// 24 bytes. (This is because of the removal of a `Box&lt;[]&gt;` in the `Ranges`</span>
<span class="doccomment">/// variant.) Given that byte based machines are typically much bigger than</span>
<span class="doccomment">/// their Unicode analogues (because they can decode UTF-8 directly), this ends</span>
<span class="doccomment">/// up being a pretty significant savings.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Inst</span> {
    <span class="doccomment">/// Match indicates that the program has reached a match state.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The number in the match corresponds to the Nth logical regular</span>
    <span class="doccomment">/// expression in this program. This index is always 0 for normal regex</span>
    <span class="doccomment">/// programs. Values greater than 0 appear when compiling regex sets, and</span>
    <span class="doccomment">/// each match instruction gets its own unique value. The value corresponds</span>
    <span class="doccomment">/// to the Nth regex in the set.</span>
    <span class="ident">Match</span>(<span class="ident">usize</span>),
    <span class="doccomment">/// Save causes the program to save the current location of the input in</span>
    <span class="doccomment">/// the slot indicated by InstSave.</span>
    <span class="ident">Save</span>(<span class="ident">InstSave</span>),
    <span class="doccomment">/// Split causes the program to diverge to one of two paths in the</span>
    <span class="doccomment">/// program, preferring goto1 in InstSplit.</span>
    <span class="ident">Split</span>(<span class="ident">InstSplit</span>),
    <span class="doccomment">/// EmptyLook represents a zero-width assertion in a regex program. A</span>
    <span class="doccomment">/// zero-width assertion does not consume any of the input text.</span>
    <span class="ident">EmptyLook</span>(<span class="ident">InstEmptyLook</span>),
    <span class="doccomment">/// Char requires the regex program to match the character in InstChar at</span>
    <span class="doccomment">/// the current position in the input.</span>
    <span class="ident">Char</span>(<span class="ident">InstChar</span>),
    <span class="doccomment">/// Ranges requires the regex program to match the character at the current</span>
    <span class="doccomment">/// position in the input with one of the ranges specified in InstRanges.</span>
    <span class="ident">Ranges</span>(<span class="ident">InstRanges</span>),
    <span class="doccomment">/// Bytes is like Ranges, except it expresses a single byte range. It is</span>
    <span class="doccomment">/// used in conjunction with Split instructions to implement multi-byte</span>
    <span class="doccomment">/// character classes.</span>
    <span class="ident">Bytes</span>(<span class="ident">InstBytes</span>),
}

<span class="kw">impl</span> <span class="ident">Inst</span> {
    <span class="doccomment">/// Returns true if and only if this is a match instruction.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_match</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Inst::Match</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">true</span>,
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">false</span>,
        }
    }
}

<span class="doccomment">/// Representation of the Save instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstSave</span> {
    <span class="doccomment">/// The next location to execute in the program.</span>
    <span class="kw">pub</span> <span class="ident">goto</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The capture slot (there are two slots for every capture in a regex,</span>
    <span class="doccomment">/// including the zeroth capture for the entire match).</span>
    <span class="kw">pub</span> <span class="ident">slot</span>: <span class="ident">usize</span>,
}

<span class="doccomment">/// Representation of the Split instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstSplit</span> {
    <span class="doccomment">/// The first instruction to try. A match resulting from following goto1</span>
    <span class="doccomment">/// has precedence over a match resulting from following goto2.</span>
    <span class="kw">pub</span> <span class="ident">goto1</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The second instruction to try. A match resulting from following goto1</span>
    <span class="doccomment">/// has precedence over a match resulting from following goto2.</span>
    <span class="kw">pub</span> <span class="ident">goto2</span>: <span class="ident">InstPtr</span>,
}

<span class="doccomment">/// Representation of the `EmptyLook` instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstEmptyLook</span> {
    <span class="doccomment">/// The next location to execute in the program if this instruction</span>
    <span class="doccomment">/// succeeds.</span>
    <span class="kw">pub</span> <span class="ident">goto</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The type of zero-width assertion to check.</span>
    <span class="kw">pub</span> <span class="ident">look</span>: <span class="ident">EmptyLook</span>,
}

<span class="doccomment">/// The set of zero-width match instructions.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">EmptyLook</span> {
    <span class="doccomment">/// Start of line or input.</span>
    <span class="ident">StartLine</span>,
    <span class="doccomment">/// End of line or input.</span>
    <span class="ident">EndLine</span>,
    <span class="doccomment">/// Start of input.</span>
    <span class="ident">StartText</span>,
    <span class="doccomment">/// End of input.</span>
    <span class="ident">EndText</span>,
    <span class="doccomment">/// Word character on one side and non-word character on other.</span>
    <span class="ident">WordBoundary</span>,
    <span class="doccomment">/// Word character on both sides or non-word character on both sides.</span>
    <span class="ident">NotWordBoundary</span>,
    <span class="doccomment">/// ASCII word boundary.</span>
    <span class="ident">WordBoundaryAscii</span>,
    <span class="doccomment">/// Not ASCII word boundary.</span>
    <span class="ident">NotWordBoundaryAscii</span>,
}

<span class="doccomment">/// Representation of the Char instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstChar</span> {
    <span class="doccomment">/// The next location to execute in the program if this instruction</span>
    <span class="doccomment">/// succeeds.</span>
    <span class="kw">pub</span> <span class="ident">goto</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The character to test.</span>
    <span class="kw">pub</span> <span class="ident">c</span>: <span class="ident">char</span>,
}

<span class="doccomment">/// Representation of the Ranges instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstRanges</span> {
    <span class="doccomment">/// The next location to execute in the program if this instruction</span>
    <span class="doccomment">/// succeeds.</span>
    <span class="kw">pub</span> <span class="ident">goto</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The set of Unicode scalar value ranges to test.</span>
    <span class="kw">pub</span> <span class="ident">ranges</span>: <span class="ident">Box</span><span class="op">&lt;</span>[(<span class="ident">char</span>, <span class="ident">char</span>)]<span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">InstRanges</span> {
    <span class="doccomment">/// Tests whether the given input character matches this instruction.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matches</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">c</span>: <span class="ident">Char</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="comment">// This speeds up the `match_class_unicode` benchmark by checking</span>
        <span class="comment">// some common cases quickly without binary search. e.g., Matching</span>
        <span class="comment">// a Unicode class on predominantly ASCII text.</span>
        <span class="kw">for</span> <span class="ident">r</span> <span class="kw">in</span> <span class="self">self</span>.<span class="ident">ranges</span>.<span class="ident">iter</span>().<span class="ident">take</span>(<span class="number">4</span>) {
            <span class="kw">if</span> <span class="ident">c</span> <span class="op">&lt;</span> <span class="ident">r</span>.<span class="number">0</span> {
                <span class="kw">return</span> <span class="bool-val">false</span>;
            }
            <span class="kw">if</span> <span class="ident">c</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">r</span>.<span class="number">1</span> {
                <span class="kw">return</span> <span class="bool-val">true</span>;
            }
        }
        <span class="self">self</span>.<span class="ident">ranges</span>
            .<span class="ident">binary_search_by</span>(<span class="op">|</span><span class="ident">r</span><span class="op">|</span> {
                <span class="kw">if</span> <span class="ident">r</span>.<span class="number">1</span> <span class="op">&lt;</span> <span class="ident">c</span> {
                    <span class="ident">Ordering::Less</span>
                } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">r</span>.<span class="number">0</span> <span class="op">&gt;</span> <span class="ident">c</span> {
                    <span class="ident">Ordering::Greater</span>
                } <span class="kw">else</span> {
                    <span class="ident">Ordering::Equal</span>
                }
            })
            .<span class="ident">is_ok</span>()
    }

    <span class="doccomment">/// Return the number of distinct characters represented by all of the</span>
    <span class="doccomment">/// ranges.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">num_chars</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">ranges</span>
            .<span class="ident">iter</span>()
            .<span class="ident">map</span>(<span class="op">|</span><span class="kw-2">&amp;</span>(<span class="ident">s</span>, <span class="ident">e</span>)<span class="op">|</span> <span class="number">1</span> <span class="op">+</span> (<span class="ident">e</span> <span class="kw">as</span> <span class="ident">u32</span>) <span class="op">-</span> (<span class="ident">s</span> <span class="kw">as</span> <span class="ident">u32</span>))
            .<span class="ident">sum</span>::<span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>() <span class="kw">as</span> <span class="ident">usize</span>
    }
}

<span class="doccomment">/// Representation of the Bytes instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">InstBytes</span> {
    <span class="doccomment">/// The next location to execute in the program if this instruction</span>
    <span class="doccomment">/// succeeds.</span>
    <span class="kw">pub</span> <span class="ident">goto</span>: <span class="ident">InstPtr</span>,
    <span class="doccomment">/// The start (inclusive) of this byte range.</span>
    <span class="kw">pub</span> <span class="ident">start</span>: <span class="ident">u8</span>,
    <span class="doccomment">/// The end (inclusive) of this byte range.</span>
    <span class="kw">pub</span> <span class="ident">end</span>: <span class="ident">u8</span>,
}

<span class="kw">impl</span> <span class="ident">InstBytes</span> {
    <span class="doccomment">/// Returns true if and only if the given byte is in this range.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matches</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">byte</span>: <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">start</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">byte</span> <span class="op">&amp;&amp;</span> <span class="ident">byte</span> <span class="op">&lt;</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">end</span>
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_size_of_inst</span>() {
        <span class="kw">use</span> <span class="ident">std::mem::size_of</span>;

        <span class="kw">use</span> <span class="ident"><span class="kw">super</span>::Inst</span>;

        <span class="macro">assert_eq!</span>(<span class="number">32</span>, <span class="ident">size_of</span>::<span class="op">&lt;</span><span class="ident">Inst</span><span class="op">&gt;</span>());
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>